      SUBROUTINE FTA4D(ARRAY,N,IREG)
      INTEGER N,M,J,NJ1,N1,IREG
      DOUBLE PRECISION ARRAY,Z,H,Y1,Y2,SUM,R,T
      DOUBLE PRECISION WR,WI,WPR,WPI,WTEMP,THETA,SYS001,ONE,ZERO,
     *TWO,HALF
      DIMENSION ARRAY(N)
      DATA SYS001/3.141592653589793D0/,ONE/1.0D0/,ZERO/0.0D0/,
     *TWO/2.0D0/,HALF/0.5D0/,Z/0.0D0/,H/0.5D0/,T/2.0D0/
      THETA=SYS001/DFLOAT(N)
      WR=ONE
      WI=ZERO
      WPR=-TWO*DSIN(HALF*THETA)**2
      WPI=DSIN(THETA)
      ARRAY(1)=Z
      M=N/2
      DO 10 J=1,M
      WTEMP=WR
      WR=WR*WPR-WI*WPI+WR
      WI=WI*WPR+WTEMP*WPI+WI
      NJ1=N-J+1
      Y1=WI*(ARRAY(J+1)+ARRAY(NJ1))
      Y2=H*(ARRAY(J+1)-ARRAY(NJ1))
      ARRAY(J+1)=Y1+Y2
      ARRAY(NJ1)=Y1-Y2
   10 CONTINUE
      CALL FTA3D(ARRAY,M,1)
      SUM=Z
      ARRAY(1)=H*ARRAY(1)
      ARRAY(2)=Z
      N1=N-1
      DO 20 J=1,N1,2
      SUM=SUM+ARRAY(J)
      ARRAY(J)=ARRAY(J+1)
      ARRAY(J+1)=SUM
   20 CONTINUE
      IF(IREG.EQ.1) GO TO 40
      R=T/DFLOAT(N)
      DO 30 J=1,N
      ARRAY(J)=R*ARRAY(J)
   30 CONTINUE
   40 RETURN
      END
